=== src/win32helpers/CMakeLists.txt ===
if (WIN32)
  add_library(getopt STATIC getopt.c getopt.h)
endif()
