=== debian/changelog ===
enblend-enfuse (4.2-8) unstable; urgency=low

  * Upgrade watch file to version 4 standard.
  * Add 45_ftbsf_microtype.diff (setting \usepackage[T1]{fontenc}) and a b-d
    on cm-super to fix FTBFS. Closes: #980666

 -- Andreas Metzler <ametzler@debian.org>  Sat, 23 Jan 2021 18:33:16 +0100

enblend-enfuse (4.2-7) unstable; urgency=low

  * Use dh v13 compat level.
  * 40_fixftbfsboost.diff: Fix FTBFS against boost 1.74 (Thanks, Anton
    Gladky!) Closes: #975081

 -- Andreas Metzler <ametzler@debian.org>  Sat, 21 Nov 2020 07:27:03 +0100

enblend-enfuse (4.2-6) unstable; urgency=medium

  * On mipsel build with -g1 instead of -g to fix FTBFS ("as: out of memory
    allocating [...] bytes [...] Fatal error: can't close enfuse-enfuse.o:
    memory exhausted").

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 Dec 2019 13:35:31 +0100

enblend-enfuse (4.2-5) unstable; urgency=medium

  * Run "wrap-and-sort --max-line-length=72 --short-indent" and add back
    autodeleted comments.
  * Set Rules-Requires-Root: no.
  * [lintian] Drop trailing empty line in changelog.
  * Use dh 12 compat.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 21 Jul 2019 15:03:39 +0200

enblend-enfuse (4.2-4) unstable; urgency=low

  * Point vcs* to salsa.
  * Upgrade to dh compat 10.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 22 Apr 2018 10:18:11 +0200

enblend-enfuse (4.2-3) unstable; urgency=medium

  * Hotfix FTBFS by adding a b-d on texlive-fonts-extra.
    Closes: #884230

 -- Andreas Metzler <ametzler@debian.org>  Thu, 21 Dec 2017 18:55:44 +0100

enblend-enfuse (4.2-2) unstable; urgency=low

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 May 2016 13:42:06 +0200

enblend-enfuse (4.2-1) experimental; urgency=low

  * New upstream version.
    + Use original tarball, drop get-orig-source target,
      debian/patches-repack/ and debian/bin/uscan_repack.sh, update
      debian/watch.
  * Rename build-directory from build-no-mp to build-def.
  * As --enable-image-cache is not supported anymore, there is no reason for
    building twice (with image-cache and with OpenMP). enblend-mp and
    enfuse-mp are therefore not shipped anymore as this functionality is
    available in the binaries without -mp suffix.
  * Update b-d for new LaTeX/hevea based build.
  * info docs are not provided anymore.
  * Ship enfuse' examples for --exposure-weight-function=.
  * Drop unused debian/sed-fix-texi-ids file.
  * Ship html documentation.
  * Add 30_hardcode_enfuse_example_dir.diff to fix the reference to
    --exposure-weight-function examples.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Apr 2016 20:20:28 +0200

enblend-enfuse (4.1.5+dfsg-1) unstable; urgency=medium

  * New upstream version.
    + really fixes gcc-6 build (#811869), drop previously added patches.
  * Build with DEB_BUILD_MAINT_OPTIONS hardening=+all.
  * Use dh.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 26 Mar 2016 16:04:19 +0100
