=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for enblend-enfuse
#
# Written by Sebastian Harl <sh@tokkee.org>.
# Andreas Metzler <ametzler@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#used by  debian/patches/20_reproducible_sig.diff
export DEB_TOP_DIR:=$(CURDIR)

include /usr/share/dpkg/architecture.mk

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

DEB_CFLAGS_MAINT_APPEND   = -Wall -pipe
DEB_CXXFLAGS_MAINT_APPEND = -Wall -pipe

ifeq ($(DEB_HOST_ARCH),mipsel)
	DEB_CFLAGS_MAINT_APPEND   += -g1
	DEB_CXXFLAGS_MAINT_APPEND += -g1
endif
export DEB_CFLAGS_MAINT_APPEND
export DEB_CXXFLAGS_MAINT_APPEND

CONFARGS := --with-openexr=yes
MYDHAUTOOPTS = --builddirectory=build-def

override_dh_auto_configure:
	dh_auto_configure --verbose \
		$(MYDHAUTOOPTS) -- $(CONFARGS) \
		--enable-openmp

override_dh_auto_build:
	dh_auto_build --verbose $(MYDHAUTOOPTS)
	cd build-def && $(MAKE) pdf

	sed -i -e "s/manual page for enblend.*/combine images using a multiresolution spline/" \
		build-def/src/enblend.1
	sed -i -e "s/manual page for enfuse.*/poor man's HDR/" \
		build-def/src/enfuse.1

override_dh_auto_install:
	dh_auto_install --verbose $(MYDHAUTOOPTS)
	mkdir -p $(CURDIR)/debian/enblend/usr/share/doc/enblend/html \
		$(CURDIR)/debian/enfuse/usr/share/doc/enfuse/html
	cd $(CURDIR)/build-def/doc && \
		grep '<img src="[^>]*\.png' enblend*.html | \
		sed -e 's/.*<img src="\([^"]*\)">.*/\1/' | sort -u | \
		xargs -r cp -v \
		--target-directory=$(CURDIR)/debian/enblend/usr/share/doc/enblend/html/ && \
		grep '<img src="[^>]*\.png' enfuse*.html | \
		sed -e 's/.*<img src="\([^"]*\)">.*/\1/' | sort -u | \
		xargs -r cp -v \
		--target-directory=$(CURDIR)/debian/enfuse/usr/share/doc/enfuse/html/

override_dh_compress:
	dh_compress -X.pdf

override_dh_installdocs:
	dh_installdocs -A -a NEWS AUTHORS

%:
	dh $@ $(MYDHAUTOOPTS)
