=== debian/watch ===
version=4

opts=dversionmangle=s/\+dfsg$// \
http://sf.net/enblend/enblend(?:-enfuse)?-([0-9.]+)@ARCHIVE_EXT@ \
	debian
