## enblend-enfuse 4.2-8+11.0trisquel0

=== debian/changelog ===
enblend-enfuse (4.2-8+11.0trisquel0) aramo; urgency=medium

  * Build as dependency of hugin.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 10 Apr 2023 20:30:05 +0000
