=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: enblend-enfuse
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Sebastian Harl <tokkee@debian.org>,
  Andreas Metzler <ametzler@debian.org>
